// mkDunes.cs
// An objlib script to build DM_/CTF_Dunes.

exec("objlib.cs");

objsetverbosity(0);

// Set to 1 to make a CTF mission, 0 for DM/TDM
$ctf = 1;

// A path marker called Origin is the only object created by hand,
// it defines center around which everything else is positioned.
$x = getPosition("MissionGroup/Origin",x);
$y = getPosition("MissionGroup/Origin",y);
$z = -10000; // -10000 means object z is relative to terrain height
$radius = 685;

function Base(%t,%x,%y,%z,%r) {
	objsetteam(%t);
	objsetorigin(%x,%y,%z,%r);
	%color = objgetteamcolor();
	%id = objsimshapegroup(0,objgetteambase());

	lobj(%id,"NavPoint","ESNavMarker_Nav"@%color,"",0,-145,-2,0);

	if ($ctf && ((%t==2) || (%t==4))) {
		// CTF flags and droppoints only for Blue and Purple teams
		lobj(%id,%color@"Flag","StaticShape_"@%color@"Flag","",0,-145,0,0);
		lobj(%id,%color@"FlagTrigger","SimTrigger_"@%color@"Flag","",0,-145,5,0);
	}
	if (!$ctf || (%t==2) || (%t==4)) {
		%dpgid = objdpgroup();
		//objdpbox(%dpgid,4,3,30,30,0,-225,10,0);
		objdpline(%dpgid,12,30,0,-225,10,0);
	}

	%dz = -8;
	lobj(%id,"HealTrigger","SimTrigger_"@%color@"Heal","",-80,-110,%dz,0);
	lobj(%id,"AmmoTrigger","SimTrigger_"@%color@"Ammo","", 80,-110,%dz,0);
	nobj(%id,"HealPad",StaticInterior,"hheal2m.dis",-80,-110,%dz,0);
	nobj(%id,"AmmoPad",StaticInterior,"hammo2m.dis", 80,-110,%dz,0);

	%d = -30;
	nobj(%id,"W1",StaticShape,"hKongcivil.dts",-160,%d-20,-20,90);
	nobj(%id,"W2",StaticShape,"hKongcivil.dts", -80,%d,-20,90);
	nobj(%id,"W3",StaticShape,"hKongcivil.dts",   0,%d-20,-20,90);
	nobj(%id,"W4",StaticShape,"hKongcivil.dts",  80,%d,-20,90);
	nobj(%id,"W5",StaticShape,"hKongcivil.dts", 160,%d-20,-20,90);
}

objsetteam(0);
objsetorigin($x,$y,$z,0);

%id = objsimshapegroup(0,"CityCenter");
nobj(%id,"BC",StaticInterior,"hbigluna3.dis",0,28,-40,0);
lobj(%id,"ZenTrigger1","SimTrigger_RedZen","",-25,0,-10,0);
lobj(%id,"ZenTrigger2","SimTrigger_RedZen","",25,0,-10,0);

%d = 510;
nobj(%id,"BN",StaticInterior,"hbigluna1.dis",0,%d,-90,0);
nobj(%id,"BE",StaticInterior,"hbigkong4t.dis",%d,0,-40,180);
nobj(%id,"BS",StaticInterior,"hbigluna1.dis",0,-%d,-90,0);
nobj(%id,"BW",StaticInterior,"hbigkong4t.dis",-%d,0,-40,0);

%d = 390;
nobj(%id,"BNE",StaticInterior,"hbigkong6t.dis",%d,%d,-30,0);
nobj(%id,"BSW",StaticInterior,"hbigkong3t.dis",-%d,-%d,-50,0);
nobj(%id,"BSE",StaticInterior,"hbigkong1t.dis",%d,-%d,-40,0);
nobj(%id,"BNW",StaticInterior,"hbigkong5t.dis",-%d,%d,-40,0);

%d = 190;
nobj(%id,"BNEI",StaticInterior,"hbigkong2t.dis",%d,%d,-50,90);
nobj(%id,"BSWI",StaticInterior,"hbigkong2t.dis",-%d,-%d,-50,90);
nobj(%id,"BSEI",StaticInterior,"hbigkong2t.dis",%d,-%d,-50,0);
nobj(%id,"BNWI",StaticInterior,"hbigkong2t.dis",-%d,%d,-50,0);

%d = 580;
nobj(%id,"BNEO",StaticInterior,"hbigkong2t.dis",%d,%d,-60,0);
nobj(%id,"BSWO",StaticInterior,"hbigkong2t.dis",-%d,-%d,-60,0);
nobj(%id,"BSEO",StaticInterior,"hbigkong2t.dis",%d,-%d,-60,90);
nobj(%id,"BNWO",StaticInterior,"hbigkong2t.dis",-%d,%d,-60,90);

if ($ctf) {
	Base(1,$x+$radius,$y,$z,90);
	Base(2,$x,$y-$radius,$z,0);
} else {
	// DM drop points
	%dpgid = objdpgroup();
	objdpcircle(%dpgid,12,$radius+240,0,0,0,0);

	Base(1,$x,$y-$radius,$z,0);
	Base(2,$x+$radius,$y,$z,90);
}
Base(3,$x-$radius,$y,$z,-90);
Base(4,$x,$y+$radius,$z,180);
